//---------------------------------------------------------------------------

#ifndef AlgParametersH
#define AlgParametersH

#include "Fparser.h"
#include "VarData.h"

//! Obiekt zawiera wszystkie parametry i dane dla algorytmow
class CAlgParameters
{
private:
public:
   	//! Konstruktor klasy
	   CAlgParameters(void);
   	//! Destruktor klasy
	   ~CAlgParameters(void);

      //! Parser wykorzystywany do sparsowania funkcji i jej wyliczania
      FunctionParser FuncParser;
      //! Zmienne danej funkcji
      CVarData Variables;

      //! Funkcja do zoptymalizowania
      char Function[MAXFUNCLEN];
      //! Zmienne funkcji
      char FuncVars[MAXFUNCLEN];
      //! Kierunek optymalizacji funkcji
      bool OptimMax;
      void SetFunction(char* Function);
      void SetFuncVars(char* FuncVars);
      // Parametry algorytmow lokalnych
      float fRangeA;
      int iTemp0;
      int iTempPlus;
      int iPercentAccepted;
      int iLk;
      float fAlfa;
      float fStop;
      float fEx;
      // Parametry algorytmow globalnych
      int iPopSize;
      int iAlgIterat;
      int iTournamentSize;
      float fCOProbability;
      float fCOA;
      float fMProbability;
      int iSelectionType;
      int iCrossOverType;
      float fRangeMutA;
      //
      int iLocalSleep;
      int iGeneticSleep;
};


//---------------------------------------------------------------------------
#endif
