//---------------------------------------------------------------------------
#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <Graphics.hpp>
#include <Buttons.hpp>
#include <Grids.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>

#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <cmath>
#include <ctime>
#include <windows.h>
#include <float.h>

#include "AlgParameters.h"
#include "Solution.h"
#include "Fparser.h"
#include "Chart.h"
#include "OptimizationThread.h"


//! Struktura opisujaca wspolrzedne miasta
typedef struct TWspolrz
{
   double x;
   double y;
} TWspolrz2;

//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
   TMainMenu *MainMenu;
   TMenuItem *Plik1;
   TMenuItem *Zamknij1;
   TMenuItem *Zapiszwyniki1;
   TMenuItem *Wczytajwyniki1;
   TMenuItem *Opcje1;
   TMenuItem *Pomoc1;
   TMenuItem *Oprogramie1;
   TMenuItem *Optymalizacja1;
   TToolBar *ToolBarMain;
   TMenuItem *Funkcja1;
   TMenuItem *N1;
   TPageControl *PageControlMain;
   TTabSheet *TabSheetFunction;
   TGroupBox *GroupBoxFunction;
   TEdit *EditFunction;
   TGroupBox *GroupBoxOptimMax;
   TRadioButton *RadioButton_max;
   TRadioButton *RadioButton_min;
   TGroupBox *GroupBoxFuncValue;
   TGroupBox *GroupBoxVariables;
   TStringGrid *StringGridVariables;
   TTabSheet *TabSheetChart;
   TPanel *PanelChartControl;
   TPanel *PanelChart;
   TGroupBox *GroupBox_fun_val;
   TLabel *LabelFuncCalc;
   TTimer *TimerChart;
   TGroupBox *GroupBoxOptions;
   TCheckBox *CheckBoxWireframe;
   TCheckBox *CheckBoxPolygon;
   TCheckBox *CheckBoxShading;
   TCheckBox *CheckBoxAxes;
   TCheckBox *CheckBoxAxesDesc;
   TCheckBox *CheckBoxFrames;
   TGroupBox *GroupBoxScale;
   TScrollBar *ScrollBarScale;
   TGroupBox *GroupBoxControl;
   TImage *Image_rotate;
   TImage *Image_position;
   TImage *Image_zoom;
   TLabel *LabelRotateLeft;
   TLabel *LabelScaleLeft;
   TLabel *LabelMoveLeft;
   TLabel *LabelRotateRight;
   TLabel *LabelMoveRight;
   TLabel *LabelScaleRight;
   TGroupBox *GroupBoxData;
   TComboBox *ComboBoxAxeX;
   TLabel *Label1;
   TLabel *Label2;
   TComboBox *ComboBoxAxeY;
   TTabSheet *TabSheetSolutions;
   TTabSheet *TabSheetOptions;
   TStringGrid *StringGridSolutions;
   TToolBar *ToolBar1;
   TSaveDialog *SaveDialog;
   TOpenDialog *OpenDialog;
   TMenuItem *Greedy1;
   TMenuItem *Steepest1;
   TMenuItem *Symulowanewyarzanie1;
   TMenuItem *N2;
   TMenuItem *Rozwizania1;
   TMenuItem *Algorytmylokalne2;
   TMenuItem *AlgorytmGenetyczny1;
   TGroupBox *GroupBoxBeforeOpt;
   TGroupBox *GroupBoxAfterOpt;
   TLabel *LabelBeforeOpt;
   TLabel *LabelAfterOpt;
   TSpeedButton *SpeedButtonCalc;
   TMenuItem *Nowafunkcja1;
   TMenuItem *Wykresfunkcji1;
   TGroupBox *GroupBoxNeigboh;
   TGroupBox *GroupBoxSA;
   TLabel *Labelneig;
   TEdit *EditA;
   TLabel *LabelTemp0;
   TLabel *LabelAlfa;
   TLabel *LabelLk;
   TLabel *LabelPercent;
   TLabel *Label3;
   TLabel *Label5;
   TEdit *EditTemp0;
   TEdit *EditTempPlus;
   TEdit *EditPercentAc;
   TEdit *EditLk;
   TEdit *EditAlfa;
   TEdit *EditStop;
   TTabSheet *TabSheetOptionsGenetic;
   TMenuItem *AlgorytmGenetyczny2;
   TGroupBox *GroupBoxSel;
   TGroupBox *GroupBoxCrossover;
   TGroupBox *GroupBoxMutation;
   TGroupBox *GroupBoxPopulation;
   TRadioButton *RadioButtonTournament;
   TRadioButton *RadioButtonRoulette;
   TLabel *Label6;
   TRadioButton *RadioButton1Point;
   TRadioButton *RadioButton2Point;
   TEdit *EditCOProbab;
   TEdit *EditMProbab;
   TLabel *Label7;
   TLabel *Label8;
   TEdit *EditPopSize;
   TLabel *Label9;
   TEdit *EditTournamentSize;
   TEdit *EditMutA;
   TLabel *Label12;
   TLabel *LabelIter;
   TEdit *EditIterations;
   TLabel *Label10;
   TEdit *EditGeneticSleep;
   TGroupBox *GroupBox1;
   TLabel *Label14;
   TEdit *EditLocalSleep;
   TMenuItem *Stop1;
   TMenuItem *N3;
   TGroupBox *GroupBoxRangeMin;
   TScrollBar *ScrollBarMinX;
   TScrollBar *ScrollBarMinY;
   TEdit *EditMinX;
   TEdit *EditMinY;
   TGroupBox *GroupBoxRangeMax;
   TScrollBar *ScrollBarMaxX;
   TScrollBar *ScrollBarMaxY;
   TEdit *EditMaxX;
   TEdit *EditMaxY;
   TMenuItem *N4;
   TMenuItem *Demonstracja1;
   TCheckBox *CheckBoxSolution;
   TLabel *Label11;
   TEdit *EditEx;
   TTimer *TimerAutoRotation;
   TGroupBox *GroupBox2;
   TCheckBox *CheckBoxAutoRotation;
   TTrackBar *TrackBarAutoRotation;
   TRadioButton *RadioButtonArithmetic;
   TLabel *Label13;
   TEdit *EditCOA;
   TPanel *Panel2;
   TSpeedButton *SpeedButtonNew;
   TSpeedButton *SpeedButtonOpen;
   TSpeedButton *SpeedButtonSave;
   TPanel *Panel1;
   TSpeedButton *SpeedButtonGreedy;
   TSpeedButton *SpeedButtonSteepest;
   TSpeedButton *SpeedButtonSA;
   TSpeedButton *SpeedButtonGeneticAlg;
   TSpeedButton *SpeedButtonStop;
   TMenuItem *N5;
   TMenuItem *Pomoc2;
   TTrackBar *TrackBarIterations;
   TTrackBar *TrackBarPopSize;
   TTrackBar *TrackBarGeneticSleep;
   TTrackBar *TrackBarTournamentSize;
   TTrackBar *TrackBarCOA;
   TTrackBar *TrackBarCOProbab;
   TTrackBar *TrackBarMutA;
   TTrackBar *TrackBarMProbab;
   TLabel *Label4;
   TLabel *Label15;
   TTrackBar *TrackBarLocalSleep;
   TTrackBar *TrackBarA;
   TTrackBar *TrackBarTemp0;
   TTrackBar *TrackBarPercentAc;
   TTrackBar *TrackBarTempPlus;
   TTrackBar *TrackBarLk;
   TTrackBar *TrackBarAlfa;
   TTrackBar *TrackBarStop;
   TBitBtn *BitBtnReset;
   TSpeedButton *SpeedButtonPause;
   TMenuItem *Pauza1;
   TTimer *TimerDemo;
   TStatusBar *StatusBar;
        TMenuItem *N6;
   TGroupBox *GroupBoxFunctionName;
   TEdit *EditFunctionName;
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall FormPaint(TObject *Sender);
   void __fastcall CheckBoxWireframeClick(TObject *Sender);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall Image_positionMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall Image_zoomMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall Image_rotateMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall PanelChartMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall PanelChartMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall PanelChartMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall CheckBoxPolygonClick(TObject *Sender);
   void __fastcall CheckBoxShadingClick(TObject *Sender);
   void __fastcall CheckBoxColorsClick(TObject *Sender);
   void __fastcall ScrollBarScaleChange(TObject *Sender);
   void __fastcall Zamknij1Click(TObject *Sender);
   void __fastcall PageControlMainMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall TimerChartTimer(TObject *Sender);
   void __fastcall SpeedButtonSteepestClick(TObject *Sender);
   void __fastcall SpeedButtonSAClick(TObject *Sender);
   void __fastcall ComboBoxAxeXChange(TObject *Sender);
   void __fastcall PageControlMainChange(TObject *Sender);
   void __fastcall SpeedButtonSaveClick(TObject *Sender);
   void __fastcall SpeedButtonOpenClick(TObject *Sender);
   void __fastcall Funkcja1Click(TObject *Sender);
   void __fastcall Rozwizania1Click(TObject *Sender);
   void __fastcall SpeedButtonGreedyClick(TObject *Sender);
   void __fastcall Oprogramie1Click(TObject *Sender);
   void __fastcall SpeedButtonCalcClick(TObject *Sender);
   void __fastcall SpeedButtonGeneticAlgClick(TObject *Sender);
   void __fastcall SpeedButtonNewClick(TObject *Sender);
   void __fastcall Algorytmylokalne2Click(TObject *Sender);
   void __fastcall AlgorytmGenetyczny2Click(TObject *Sender);
   void __fastcall SpeedButtonStopClick(TObject *Sender);
   void __fastcall ScrollBarMinXChange(TObject *Sender);
   void __fastcall ScrollBarMinYChange(TObject *Sender);
   void __fastcall ScrollBarMaxXChange(TObject *Sender);
   void __fastcall ScrollBarMaxYChange(TObject *Sender);
   void __fastcall Demonstracja1Click(TObject *Sender);
   void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
   void __fastcall TimerAutoRotationTimer(TObject *Sender);
   void __fastcall Wykresfunkcji1Click(TObject *Sender);
   void __fastcall Pomoc2Click(TObject *Sender);
   void __fastcall TimerDemoTimer(TObject *Sender);
   void __fastcall TrackBarIterationsChange(TObject *Sender);
   void __fastcall TrackBarPopSizeChange(TObject *Sender);
   void __fastcall TrackBarGeneticSleepChange(TObject *Sender);
   void __fastcall TrackBarTournamentSizeChange(TObject *Sender);
   void __fastcall TrackBarCOAChange(TObject *Sender);
   void __fastcall TrackBarCOProbabChange(TObject *Sender);
   void __fastcall TrackBarMutAChange(TObject *Sender);
   void __fastcall TrackBarMProbabChange(TObject *Sender);
   void __fastcall BitBtnResetClick(TObject *Sender);
   void __fastcall SpeedButtonPauseClick(TObject *Sender);
   void __fastcall Pauza1Click(TObject *Sender);
   void __fastcall TrackBarLocalSleepChange(TObject *Sender);
   void __fastcall TrackBarAChange(TObject *Sender);
   void __fastcall TrackBarTemp0Change(TObject *Sender);
   void __fastcall TrackBarPercentAcChange(TObject *Sender);
   void __fastcall TrackBarTempPlusChange(TObject *Sender);
   void __fastcall TrackBarLkChange(TObject *Sender);
   void __fastcall TrackBarAlfaChange(TObject *Sender);
   void __fastcall TrackBarStopChange(TObject *Sender);
   void __fastcall EditMinXKeyPress(TObject *Sender, char &Key);
   void __fastcall EditMinYKeyPress(TObject *Sender, char &Key);
   void __fastcall EditMaxXKeyPress(TObject *Sender, char &Key);
   void __fastcall EditMaxYKeyPress(TObject *Sender, char &Key);

private:	// User declarations
    HDC hDC;
    bool ChartReady, bDemo, bThreadSuspend;
    int PosX, PosY;
    float kx, ky;
    int LastX, LastY;
    bool LeftButton, RightButton;
    int LeftButtonAction, RightButtonAction;
    float MinX, MinY, MinZ, MaxX, MaxY, MaxZ;
    int iFirstVar;
    int iSecondVar;
    bool bResultsOpen, bNewSolutions;
    AnsiString sLastFunction;
    vVecData1D vFuncValues;
    
    void Redraw(void);
    int PrepareData(bool bOnlyData = false);
    void PrepareFunction(void);
    void SetScrolls(bool bOneVar, int iFirstVar, int iSecondVar);

    void CalcFunc2DValue(int iFirstVar);
    void CalcFunc3DValue(int iFirstVar, int iSecondVar);

    void BlockButtons(void);
    void ReleaseButtons(void);
    void ThreadSter(void);

   FunctionParser fp;
   OptimizationThread *ot;

public:		// User declarations

   bool bStop;
   bool bSpiral;
   CAlgParameters AlgParam;
   COpenGLView *Chart;
   CSolution Solution;
   CSolution Population;

   __fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
