//---------------------------------------------------------------------------

#ifndef OptimizationThreadH
#define OptimizationThreadH
#include "AlgParameters.h"
#include "Solution.h"
#include "GlobalSearch.h"
#include "LocalSearch.h"

//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//! Klasa wyliczajca rozwizania w osobnym wtku
class OptimizationThread : public TThread
{
private:
   //! Zwraca true jezel algorytm sie zakonczyl
   bool bThreadFinish;
   //! Zawiera typ algorytmu wyliczjcego rozwizania
   int iTypeAlg;
   //! Obiekt zawiera wszystkie parametry i dane dla algorytmow
   CAlgParameters AlgParam;
   //! Obiekt zawiera rozwiazanie wyliczone przez algorytmy
   CSolution Solution;
   //! Obiekt zawiera algorytmy lokalne
   CGlobalSearch gs;
   //! Obiekt zawiera algorytm genetyczny
   CLocalSearch ls;

protected:
   void __fastcall Execute();
public:

   __fastcall OptimizationThread(bool CreateSuspended, int iTypeAlg, CAlgParameters AlgParam);
   //! Zwraca wyniki wyliczone przez algorytm
   CSolution __fastcall GetResults();
   //! Zwraca aktualny stan populacja algorytmu genetycznego
   CSolution __fastcall GetPopulationGA();
   //! Zwraca stan watku
   bool __fastcall GetState();
};
//---------------------------------------------------------------------------
#endif
