#pragma hdrstop
#include "Solution.h"

//! Konstruktor klasy
CSolution::CSolution(void)
{
	//! Wstepne wyczyszczenie tablic
	vSolutions.clear();
}

//! Destruktor klasy
CSolution::~CSolution(void)
{
	/*!
	Usuniecie wszystkich elementow z tablic
	i zwolnienie zajmowanej przez nia pamieci
	*/
	vSolutions.clear();
}

void CSolution::Clear(void)
{
	vSolutions.clear();
}

int CSolution::GetNumberOfSol(void)
{
   return vSolutions.size();
}

int CSolution::GetNumberOfVar(void)
{
   return vSolutions[0].vSol.size();
}

void CSolution::Add(std::vector<float> vSol, float func)
{
   TSol NewSol;
   NewSol.vSol = vSol;
   NewSol.func = func;
   vSolutions.push_back(NewSol);
}

void CSolution::AddSolution(TSol Solution)
{
   vSolutions.push_back(Solution);
}

TSol CSolution::GetSolution(int indexSol)
{
   return vSolutions[indexSol];
}

TSol CSolution::GetBestSolution(bool bOptimMax)
{
   TSol Best;
   Best = vSolutions[0];
   for (unsigned int i = 1; i < vSolutions.size(); i++)
      if (bOptimMax)
      {
         if (vSolutions[i].func > Best.func) Best = vSolutions[i];
      }
      else
      {
         if (vSolutions[i].func < Best.func) Best = vSolutions[i];
      }
   return Best;
}

float CSolution::GetSolutionVar(int indexSol, int indexVar)
{
   return vSolutions[indexSol].vSol[indexVar];
}

float CSolution::GetLastSolVar(int indexVar)
{
   return vSolutions[vSolutions.size() - 1].vSol[indexVar];
}

float CSolution::GetFunc(int indexSol)
{
   return vSolutions[indexSol].func;
}

float CSolution::GetLastFunc(void)
{
   return vSolutions[vSolutions.size() - 1].func;
}

//---------------------------------------------------------------------------
#pragma package(smart_init)
