//---------------------------------------------------------------------------

#ifndef SolutionH
#define SolutionH

#include <vector>
#include <stdio.h>

/*!
 Struktura opisujaca pojedyncze rozwiazanie
 Wartosci wszystkich zmiennych
 oraz wartosc funkcji dla tych zmiennych
*/
typedef struct TSol
{
   std::vector<float> vSol;
   float func;
} TSol2;


//! Klasa zawierajca rozwizania
class CSolution
{

private:

      //! Wektor zawierajacy wszystkie rozwizania:
      std::vector<TSol> vSolutions;

public:
   	//! Konstruktor klasy
	   CSolution(void);
   	//! Destruktor klasy - zwolnienie pamieci
	   ~CSolution(void);

      //! Usuwa wszystkie rozwizania
      void Clear(void);
      //! Zwraca liczbe wszystkich rozwiazan
      int GetNumberOfSol(void);
      //! Zwraca liczbe wszystkich zmiennych
      int GetNumberOfVar(void);
      //! Dodaje rozwizanie
      void Add(std::vector<float> vSol, float func);
      //! Dodaje rozwizanie
      void AddSolution(TSol Solution);
      //! Zwraca cale rozwiazanie o podanym indeksie
      TSol GetSolution(int indexSol);
      //! Zwraca najlepsze rozwiazanie ze wszystkich
      TSol GetBestSolution(bool bOptimMax);
      //! Zwraca warosc wybranej zmiennej dla wybranego rozwiazania
      float GetSolutionVar(int indexSol, int indexVar);
      //! Zwraca warosc wybranej zmiennej dla ostatnio dodanego rozwiazania
      float GetLastSolVar(int indexVar);
      //! Zwraca warosc funkcji dla wybranego rozwiazania
      float GetFunc(int indexSol);
      //! Zwraca warosc funkcji dla ostatnio dodanego rozwiazania
      float GetLastFunc(void);
};

//---------------------------------------------------------------------------
#endif
